//+------------------------------------------------------------------+
//|                                               Sentinal Index.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window 
//#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
extern bool zero_line_mode = false;
extern int MA_period = 1;
extern int MA_method_0_to_3 = 1;
extern int bars_to_calculate = 250;
extern bool flip_line_up_side_down = false;
extern double	USD = 1.0,	// weights
					JPY = 1.0,
					GBP = 1.0,
					CHF = 1.0,
					CAD = 1.0,
					AUD = 1.0,
					NZD = 1.0;
					
double BIAS = 0;	// starting value for the first bar
//---- indicator buffers
double	Index[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	string name = "";

//---- indicator line
	IndicatorShortName(name);
   IndicatorBuffers(1);
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,EMPTY);
   SetIndexBuffer(0,Index);
   SetIndexLabel(0,NULL);
//----
   return(0);
}

//+------------------------------------------------------------------+
//| Calculates the relative change of symbol between bar i and i+1	|
//+------------------------------------------------------------------+
double Sentinal(string symbol, int i = 0)
{
double    a = iMA(symbol,0,MA_period,0,MA_method_0_to_3,4,i),
          b = iMA(symbol,0,MA_period,0,MA_method_0_to_3,4,(i+1)),
			 move = a-b;

	if(a==0||b==0)
	{
		if(i==0)
			Print("Warning: No "+symbol+" data loaded.");
		return(0);
	}

	double moveInPercent = 100*move/b;
/*	double pointSize = MarketInfo(symbol,MODE_POINT),
			 tickValue = MarketInfo(symbol,MODE_TICKVALUE);
	double moveInPips = move / pointSize,
	  		 moveInUSD  = moveInPips * tickValue;

	switch(MODE)
	{
		case 0: return(moveInPercent);
		case 1: return(moveInPips);
		case 2: return(moveInUSD);
	}
*/

	return(moveInPercent);
}

//+------------------------------------------------------------------+
int start()
{
//	int iMax = Bars - 1 - IndicatorCounted();
	int iMax = Bars -1 ;

	if(iMax >= bars_to_calculate)
	{
		iMax = bars_to_calculate;
   }
   
   Index[iMax+1] = BIAS;

//----
   for(int i = iMax; i >= 0; i--)
	{
		double x = 0, v = 0;

		x +=  USD * Sentinal("EURUSD",i);
		x +=  JPY * Sentinal("EURJPY",i);
		x +=  GBP * Sentinal("EURGBP",i);
		x +=  CHF * Sentinal("EURCHF",i);
		x +=  CAD * Sentinal("EURCAD",i);
		x +=  AUD * Sentinal("EURAUD",i);
		x +=  NZD * Sentinal("EURNZD",i);
		
if (flip_line_up_side_down)
      x *= -1;
      
 if (zero_line_mode){
      if (x == 0)
	      Index[i] = 0;
	  if (x > 0)
	      Index[i] = x + (v/100);
	  if (x < 0)
	      Index[i] = x - (v/100); 
	  }
   else {
       if (x == 0)
	  	     Index[i] = Index[i+1];
	    if (x > 0)
	        Index[i] = Index[i+1] + x + (v/100);
	    if (x < 0)
	        Index[i] = Index[i+1] + x - (v/100);	        
	   }
	}

	return(0);
}


